#include <location/location-gps-device.h>
#include <location/location-gpsd-control.h>

typedef struct {
float latitude;
float longitude;
} Locations;

/*
Locations (Coordinate a, int offset)
{
	Coordinate ret;

	return ret;
}*/

float latitude=-1.0, longitude=-1.0;


static void on_error(LocationGPSDControl *control, LocationGPSDControlError error)
{
	printf("location error: %d... quitting", error);
}

static void on_changed(LocationGPSDevice *device, gpointer data)
{

	if (!device)
		return;

	if (device->fix) {
		if (device->fix->fields & LOCATION_GPS_DEVICE_LATLONG_SET) {
			latitude= device->fix->latitude;
			longitude= device->fix->longitude;
			printf("lat = %f, long = %f", latitude, longitude);

			//Show note with information
			std::string str;
			std::ostringstream oss;

			oss << "Lat = " << device->fix->latitude << ", long = " << device->fix->longitude;
			str=oss.str();

			//Hildon::Note helloworld_note(Hildon::NOTE_TYPE_INFORMATION, str);
			//helloworld_note.run();
			location_gpsd_control_stop((LocationGPSDControl *) data);
		}
	}
}

static void on_stop(LocationGPSDControl *control)
{
	g_debug("quitting");
}

static gboolean start_location(gpointer data)
{
	location_gpsd_control_start((LocationGPSDControl *) data);
	return FALSE;
}
