/*******************************************************************************
 * Copyright (c) 2007-2008 INdT.
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.

 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.

 *  You should have received a copy of the GNU Lesser General Public License
 *  along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

/*
 ============================================================================
 Name        : main.cc
 Author      : DoNothing Group
 Version     : 0.1
 Description : CPP Hello World
 ============================================================================
 */

#include "config.h"

#include <libosso.h>
#include <hildonmm.h>
#include <iostream>
#include <glibmm/i18n.h> /* Must be after <iostream> */

#include "mywindow.h"

/*
#include <location/location-gps-device.h>
#include <location/location-gpsd-control.h>

static void on_error(LocationGPSDControl *control, LocationGPSDControlError error, gpointer data)
{
	g_debug("location error: %d... quitting", error);
	g_main_loop_quit((GMainLoop *) data);
}

static void on_changed(LocationGPSDevice *device, gpointer data)
{
	if (!device)
		return;

	if (device->fix) {
		if (device->fix->fields & LOCATION_GPS_DEVICE_LATLONG_SET) {
			g_debug("lat = %f, long = %f", device->fix->latitude, device->fix->longitude);
			location_gpsd_control_stop((LocationGPSDControl *) data);
		}
	}
}

static void on_stop(LocationGPSDControl *control, gpointer data)
{
	g_debug("quitting");
	g_main_loop_quit((GMainLoop *) data);
}

static gboolean start_location(gpointer data)
{
	location_gpsd_control_start((LocationGPSDControl *) data);
	return FALSE;
}
*/

int main(int argc, char *argv[])
{
	/* i18n initialization */
	bindtextdomain(GETTEXT_PACKAGE, HELLOWORLD_LOCALEDIR);
	bind_textdomain_codeset(GETTEXT_PACKAGE, "UTF-8");
	textdomain(GETTEXT_PACKAGE);

	/*
	////

	LocationGPSDControl *control;
	LocationGPSDevice *device;
	GMainLoop *loop;

	g_type_init();
	loop = g_main_loop_new(NULL, FALSE);


	control = location_gpsd_control_get_default();
	device = g_object_new(LOCATION_TYPE_GPS_DEVICE, NULL);

	g_object_set(G_OBJECT(control),
		"preferred-method", LOCATION_METHOD_USER_SELECTED,
		"preferred-interval", LOCATION_INTERVAL_DEFAULT,
		NULL);

	g_signal_connect(control, "error-verbose", G_CALLBACK(on_error), loop);
	g_signal_connect(device, "changed", G_CALLBACK(on_changed), control);
	g_signal_connect(control, "gpsd-stopped", G_CALLBACK(on_stop), loop);

	g_idle_add(start_location, control);


	////
	 *
	 */

	/* Initialize gtkmm and checks the arguments passed to your application */
	Gtk::Main main_loop(&argc, &argv);

	/* Initialize the hildonmm libraries */
	Hildon::init();

	/* Initialize libosso environment */
	osso_context_t* osso_context = osso_initialize("helloworld", "0.1", TRUE, 0);
	if(!osso_context)
		std::cerr << "osso_initialize() failed." << std::endl;

	/* Set the application name */
	Glib::set_application_name(PACKAGE_STRING);

	/* Create an object for the main Window and attach it to the program */
	MyWindow window;
	Hildon::Program::get_instance()->add_window(window);

	/* Begin the main application */
	main_loop.run(window);

	/* Clean the libosso environment */
	osso_deinitialize(osso_context);

	return 0;
}
