/*
 ============================================================================
 Name        : mywindow.cpp
 Author      : DoNothing Group
 Version     : 0.1
 ============================================================================
 */
#include <glibmm/i18n.h>
#include <gtkmm.h>
#include <hildonmm.h>
#include "mywindow.h"
#include "location.c"

extern float longitude, latitude;

/* Class constructor */
MyWindow::MyWindow() :
	m_button_1(_("Factory -> Warehouse")),m_button_2(_("Warehouse -> Transport")),m_button_3(_("Product Information")),m_button_4(_("Transfer to Location 1")),m_hbox(), m_label_1(_("Product Name")), m_label_2(_("Concrete Boulders")), m_label_3(_("Category")), m_label_4(_("Boulder-3-2")),
	m_label_5(_("Location")), m_button_5(_("Back")) ,m_button_6(_("Transfer to Location 2"))
{
	Hildon::Program::get_instance()->set_common_app_menu(m_main);


	m_hbox.pack_start(m_button_1);
	m_hbox.pack_start(m_button_2);
	m_hbox.pack_start(m_button_3);

	m_vbox1.pack_start(m_label_1);
	m_vbox2.pack_start(m_label_2);
	m_vbox1.pack_start(m_label_3);
	m_vbox2.pack_start(m_label_4);
	m_vbox1.pack_start(m_label_5);
	m_vbox2.pack_start(m_image_1);
	m_vbox2.pack_start(m_button_4);
	m_vbox1.pack_start(m_button_6);
	m_vbox2.pack_start(m_button_5);
	m_hbox2.pack_start(m_vbox1);
	m_hbox2.pack_start(m_vbox2);
//m_hbox.
	//m_hbox.set_homogeneous(true);
	add(m_hbox);
	/* Attach the callback function to signal handler */

	m_button_1.signal_clicked().connect(sigc::mem_fun(*this, &MyWindow::on_menu_1));
	m_button_2.signal_clicked().connect(sigc::mem_fun(*this, &MyWindow::on_menu_2));
	m_button_3.signal_clicked().connect(sigc::mem_fun(*this, &MyWindow::on_menu_3));
	m_button_4.signal_clicked().connect(sigc::mem_fun(*this, &MyWindow::on_menu_4));
	m_button_5.signal_clicked().connect(sigc::mem_fun(*this, &MyWindow::on_menu_5));
	m_button_6.signal_clicked().connect(sigc::mem_fun(*this, &MyWindow::on_menu_6));

	control = location_gpsd_control_get_default();
	device = (LocationGPSDevice*)g_object_new(LOCATION_TYPE_GPS_DEVICE, NULL);

	g_object_set(G_OBJECT(control),
			"preferred-method", LOCATION_METHOD_USER_SELECTED,
			"preferred-interval", LOCATION_INTERVAL_DEFAULT,
			NULL);
	g_signal_connect(control, "error-verbose", G_CALLBACK(on_error), NULL);
	g_signal_connect(device, "changed", G_CALLBACK(on_changed), control);
	g_signal_connect(control, "gpsd-stopped", G_CALLBACK(on_stop), NULL);

	//g_idle_add(start_location, control);
	location_gpsd_control_start(control);


	/* Make all menu widgets visible */
	show_all();
}

/* Class destructor */
MyWindow::~MyWindow()
{
}

void MyWindow::on_menu_1()
{
	/* Create and show a dialog */
		//Hildon::Banner::set_timeout(*this,300);
		Hildon::Banner::show_information(*this, "Reading Barcode...");
		//Hildon::Banner:: set_timeout(9000);
	remove();
	add(m_hbox2);
	show_all();
}
void MyWindow::on_menu_2()
{
	/* Create and show a dialog */
	Hildon::Note helloworld_note(Hildon::NOTE_TYPE_INFORMATION, _("Warehouse to transport Management"));
	helloworld_note.run();
}
void MyWindow::on_menu_3()
{

	Hildon::Note helloworld_note(Hildon::NOTE_TYPE_INFORMATION, _("Factory to warehouse management"));
	//helloworld_note.run();*/
	//this->hide();
}

void MyWindow::on_menu_4()
{
	//Show note with information
	std::string str;
	std::ostringstream oss;
	char product_name_from_db[50] = "Concrete Boulders";
	char category_from_db[25] = "Concrete-3-2";
	char loc_from_db[25] = "62.523 , 30.263";

	oss << "The location of product " << product_name_from_db << " from category " << category_from_db << " is at " << loc_from_db << "\n";
	oss << "Your location: Latitude = " << latitude << ", Longitude = " << longitude << "\n\n";
	oss << "Good, the product is transfered in right place!! :)";
	str=oss.str();

	Hildon::Note helloworld_note(Hildon::NOTE_TYPE_INFORMATION, str);
	helloworld_note.run();
}

void MyWindow::on_menu_6()
{
	std::string str;
	std::ostringstream oss;

	char product_name_from_db[50] = "Concrete Bars";
	char category_from_db[25] = "Concrete-5-2";
	char loc_from_db[25] = "50.563 , 38.274";

	oss << "The location of product " << product_name_from_db << " from category " << category_from_db << " is at " << loc_from_db << "\n";
	oss << "You location: Latitude = " << latitude << ", Longitude = " << longitude << "\n\n";
	oss << "Sorry, The product you transfered is in wrong place!!";
	str=oss.str();

	Hildon::Note helloworld_note(Hildon::NOTE_TYPE_PROGRESSBAR, str);
	helloworld_note.run();

	remove();
	add(m_hbox2);
	show_all();
}

void MyWindow::on_menu_5()
{
	remove();
	add(m_hbox);
	show_all();
}

