/*******************************************************************************
 * Copyright (c) 2007-2008 INdT.
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.

 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.

 *  You should have received a copy of the GNU Lesser General Public License
 *  along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

/*
 ============================================================================
 Name        : mywindow.h
 Author      : DoNothing Group
 Version     : 0.1
 ============================================================================
 */

#ifndef MYWINDOW_H
#define MYWINDOW_H

#include <gtkmm.h>
#include <hildonmm.h>
#include <mywindow2.h>
#include <location/location-gps-device.h>
#include <location/location-gpsd-control.h>

class MyWindow : public Hildon::Window
{
public:
	MyWindow();
	virtual ~MyWindow();

protected:

	//Hildon::Banner* m_banner;

	/* Signal handlers */
	void on_menu_1();
	void on_menu_2();
	void on_menu_3();
	void on_menu_4();
	void on_menu_5();
	void on_menu_6();

	/* Menu object */
	Hildon::AppMenu m_main;
	MyWindow2 window2;

	/* The menu buttons */
	Gtk::Button m_button_helloworld;
	Gtk::Button m_button_1;
	Gtk::Button m_button_2;
	Gtk::Button m_button_3;
	Gtk::HBox m_hbox;

	//views
	Gtk::HBox m_hbox2;
	Gtk::VBox m_vbox1, m_vbox2;
	Gtk::Button m_button_4;
	Gtk::Button m_button_5;
	Gtk::Button m_button_6;
	Gtk::Label m_label_1;
	Gtk::Label m_label_2;
	Gtk::Label m_label_3;
	Gtk::Label m_label_4;
	Gtk::Label m_label_5;
	Gtk::Image m_image_1;

	LocationGPSDControl * control;
	LocationGPSDevice * device;

};

#endif /* MYWINDOW_H */
